      SUBROUTINE RK4(y,dydx,n,xn,h,yout,derivs,npartic)
 
      integer n,NMAX
      real*8 h,xn,dydx(n),y(n),yout(n)
      external derivs
      parameter (NMAX=50)
      integer i
      real*8 h6,hh,xh,dym(NMAX),dyt(NMAX),yt(NMAX)

      hh = h*0.5
      h6 = h/6.
      xh = xn + hh
 
c      write(*,*) '*********************************'
c      write(*,*) '******   RK4   ******************'

      do i = 1, n
        yt(i) = y(i) + hh*dydx(i)
      enddo


      call DERIVS(xh,yt,dyt,n,npartic, 1)


      do i = 1, n
        yt(i) = y(i) + hh*dyt(i)
      enddo


      call DERIVS(xh,yt,dym,n,npartic, 2)


      do i = 1, n
        yt(i)  = y(i) + h*dym(i)
        dym(i) = dyt(i) + dym(i)
      enddo

      call DERIVS(x+h,yt,dyt,n,npartic, 3)

      do i = 1, n
        yout(i) = y(i) + h6*(dydx(i)+dyt(i)+2.*dym(i))
       enddo
   

      RETURN
      END

c************************************************************************
c************************************************************************
c************************************************************************
c************************************************************************
c************************************************************************
c************************************************************************
      SUBROUTINE DERIVS(xn,yy,dydx,n,II,ncallderivs)

      implicit real*8(a-h,o-z)
      include 'param.h'

      COMMON /DATA/npart,STEPS,OLDSTEP,iflag,ilift,R,A,W,dump
      COMMON /PART/xdata,ydata,vx,vy,x,y,vvx,vvy,dt
  
      dimension xdata(nmax),ydata(nmax)
      dimension vx(nmax),vy(nmax)
      dimension vvx(nmax),vvy(nmax),x(nmax),y(nmax)

      real*8 dt,UUX,DUUXDY,xn

      integer n,II
      integer OLDSTEP

      dimension dydx(n)
      dimension yy(n)

 

       PI=4.*ATAN(1.)

      dydx(1)=yy(3)
      dydx(2)=yy(4)

      dydx(3)=A*(-yy(3)+sin(yy(1))*cos(yy(2)) +
     &        0.5*R/A*(yy(3)*cos(yy(1))*cos(yy(2)) -
     &                 yy(4)*sin(yy(1))*sin(yy(2))) +
     &                 R/A*sin(yy(1))*cos(yy(1))) +
     & ilift*(
     &        0.726*sqrt(A*R)*(2*sin(yy(1))*sin(yy(2)))*(-
     &              cos(yy(1))*sin(yy(2))-
     &              yy(4))*1/sqrt(abs(2*sin(yy(1))*sin(yy(2))))
     &       )   


      dydx(4)=A*(-yy(4)-cos(yy(1))*sin(yy(2)) + W +
     &        0.5*R/A*(yy(3)*sin(yy(1))*sin(yy(2)) -
     &                 yy(4)*cos(yy(1))*cos(yy(2))) +
     &                 R/A*sin(yy(2))*cos(yy(2)))- 
     &  ilift*(
     &        0.726*sqrt(A*R)*(2*sin(yy(1))*sin(yy(2)))*(
     &              sin(yy(1))*cos(yy(2))-
     &              yy(3))*1/sqrt(abs(2*sin(yy(1))*sin(yy(2))))
     &        )       


c-----------
      RETURN
      END



